diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-socket-base.cc ns-3.47/src/internet/model/tcp-socket-base.cc
--- ns-3.46/src/internet/model/tcp-socket-base.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-socket-base.cc	2026-02-16 16:08:49.621230000 -0800
@@ -139,6 +139,11 @@
                           BooleanValue(true),
                           MakeBooleanAccessor(&TcpSocketBase::m_timestampEnabled),
                           MakeBooleanChecker())
+            .AddAttribute("Fack",
+                          "Enable or disable FACK option",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&TcpSocketBase::m_fackEnabled),
+                          MakeBooleanChecker())
             .AddAttribute(
                 "MinRto",
                 "Minimum retransmit timeout value",
@@ -194,6 +199,11 @@
                                           "On",
                                           TcpSocketState::AcceptOnly,
                                           "AcceptOnly"))
+            .AddAttribute("UseAbe",
+                          "Parameter to set ABE functionality",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&TcpSocketBase::m_useAbe),
+                          MakeBooleanChecker())
             .AddTraceSource("RTO",
                             "Retransmission timeout",
                             MakeTraceSourceAccessor(&TcpSocketBase::m_rto),
@@ -238,6 +248,10 @@
                             "Socket estimation of bytes in flight",
                             MakeTraceSourceAccessor(&TcpSocketBase::m_bytesInFlightTrace),
                             "ns3::TracedValueCallback::Uint32")
+            .AddTraceSource("FackAwnd",
+                            "Socket estimation of bytes in flight by FACK",
+                            MakeTraceSourceAccessor(&TcpSocketBase::m_fackAwndTrace),
+                            "ns3::TracedValueCallback::Uint32")
             .AddTraceSource("HighestRxSequence",
                             "Highest sequence number received from peer",
                             MakeTraceSourceAccessor(&TcpSocketBase::m_highRxMark),
@@ -293,11 +307,15 @@
     : TcpSocket()
 {
     NS_LOG_FUNCTION(this);
+
     m_txBuffer = CreateObject<TcpTxBuffer>();
     m_txBuffer->SetRWndCallback(MakeCallback(&TcpSocketBase::GetRWnd, this));
     m_tcb = CreateObject<TcpSocketState>();
     m_rateOps = CreateObject<TcpRateLinux>();
 
+    m_sndFack = 0;
+    m_outstandingRetransBytes = 0;
+
     m_tcb->m_rxBuffer = CreateObject<TcpRxBuffer>();
 
     m_tcb->m_pacingRate = m_tcb->m_maxPacingRate;
@@ -310,47 +328,59 @@
     ok = m_tcb->TraceConnectWithoutContext(
         "PacingRate",
         MakeCallback(&TcpSocketBase::UpdatePacingRateTrace, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source PacingRate");
 
     ok = m_tcb->TraceConnectWithoutContext("CongestionWindow",
                                            MakeCallback(&TcpSocketBase::UpdateCwnd, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source CongestionWindow");
 
     ok = m_tcb->TraceConnectWithoutContext("CongestionWindowInflated",
                                            MakeCallback(&TcpSocketBase::UpdateCwndInfl, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source CongestionWindowInflated");
 
     ok = m_tcb->TraceConnectWithoutContext("SlowStartThreshold",
                                            MakeCallback(&TcpSocketBase::UpdateSsThresh, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source SlowStartThreshold");
 
     ok = m_tcb->TraceConnectWithoutContext("CongState",
                                            MakeCallback(&TcpSocketBase::UpdateCongState, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source CongState");
 
     ok = m_tcb->TraceConnectWithoutContext("EcnState",
                                            MakeCallback(&TcpSocketBase::UpdateEcnState, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source EcnState");
 
     ok =
         m_tcb->TraceConnectWithoutContext("NextTxSequence",
                                           MakeCallback(&TcpSocketBase::UpdateNextTxSequence, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source NextTxSequence");
 
     ok = m_tcb->TraceConnectWithoutContext("HighestSequence",
                                            MakeCallback(&TcpSocketBase::UpdateHighTxMark, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source HighestSequence");
 
     ok = m_tcb->TraceConnectWithoutContext("BytesInFlight",
                                            MakeCallback(&TcpSocketBase::UpdateBytesInFlight, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source BytesInFlight");
+
+    ok = m_tcb->TraceConnectWithoutContext("FackAwnd",
+                                           MakeCallback(&TcpSocketBase::UpdateFackAwnd, this));
+    NS_ASSERT_MSG(ok, "Could not connect trace source FackAwnd");
 
     ok = m_tcb->TraceConnectWithoutContext("RTT", MakeCallback(&TcpSocketBase::UpdateRtt, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source RTT");
 
     ok = m_tcb->TraceConnectWithoutContext("LastRTT",
                                            MakeCallback(&TcpSocketBase::UpdateLastRtt, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source LastRTT");
+}
+
+void
+TcpSocketBase::NotifyConstructionCompleted()
+{
+    NS_LOG_FUNCTION(this);
+
+    SetUseAbe(m_useAbe);
 }
 
 TcpSocketBase::TcpSocketBase(const TcpSocketBase& sock)
@@ -393,6 +423,7 @@
       m_sndWindShift(sock.m_sndWindShift),
       m_timestampEnabled(sock.m_timestampEnabled),
       m_timestampToEcho(sock.m_timestampToEcho),
+      m_fackEnabled(sock.m_fackEnabled),
       m_recover(sock.m_recover),
       m_recoverActive(sock.m_recoverActive),
       m_retxThresh(sock.m_retxThresh),
@@ -448,51 +479,57 @@
         m_tcb->m_sendEmptyPacketCallback = MakeCallback(&TcpSocketBase::SendEmptyPacket, this);
     }
 
+    m_sndFack = sock.m_sndFack;
+    m_outstandingRetransBytes = sock.m_outstandingRetransBytes;
+
     bool ok;
 
     ok = m_tcb->TraceConnectWithoutContext(
         "PacingRate",
         MakeCallback(&TcpSocketBase::UpdatePacingRateTrace, this));
+    NS_ASSERT_MSG(ok, "Could not connect trace source PacingRate");
 
     ok = m_tcb->TraceConnectWithoutContext("CongestionWindow",
                                            MakeCallback(&TcpSocketBase::UpdateCwnd, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source CongestionWindow");
 
     ok = m_tcb->TraceConnectWithoutContext("CongestionWindowInflated",
                                            MakeCallback(&TcpSocketBase::UpdateCwndInfl, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source CongestionWindowInflated");
 
     ok = m_tcb->TraceConnectWithoutContext("SlowStartThreshold",
                                            MakeCallback(&TcpSocketBase::UpdateSsThresh, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source SlowStartThreshold");
 
     ok = m_tcb->TraceConnectWithoutContext("CongState",
                                            MakeCallback(&TcpSocketBase::UpdateCongState, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source CongState");
 
     ok = m_tcb->TraceConnectWithoutContext("EcnState",
                                            MakeCallback(&TcpSocketBase::UpdateEcnState, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source EcnState");
 
     ok =
         m_tcb->TraceConnectWithoutContext("NextTxSequence",
                                           MakeCallback(&TcpSocketBase::UpdateNextTxSequence, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source NextTxSequence");
 
     ok = m_tcb->TraceConnectWithoutContext("HighestSequence",
                                            MakeCallback(&TcpSocketBase::UpdateHighTxMark, this));
-    NS_ASSERT(ok == true);
-
+    NS_ASSERT_MSG(ok, "Could not connect trace source HighestSequence");
     ok = m_tcb->TraceConnectWithoutContext("BytesInFlight",
                                            MakeCallback(&TcpSocketBase::UpdateBytesInFlight, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source BytesInFlight");
+
+    ok = m_tcb->TraceConnectWithoutContext("FackAwnd",
+                                           MakeCallback(&TcpSocketBase::UpdateFackAwnd, this));
 
     ok = m_tcb->TraceConnectWithoutContext("RTT", MakeCallback(&TcpSocketBase::UpdateRtt, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source RTT");
 
     ok = m_tcb->TraceConnectWithoutContext("LastRTT",
                                            MakeCallback(&TcpSocketBase::UpdateLastRtt, this));
-    NS_ASSERT(ok == true);
+    NS_ASSERT_MSG(ok, "Could not connect trace source LastRTT");
 }
 
 TcpSocketBase::~TcpSocketBase()
@@ -1791,6 +1828,16 @@
         // CA_RECOVERY and reducing sending rate again.
         NS_ASSERT((m_dupAckCount <= m_retxThresh) || m_recoverActive);
 
+        uint32_t fackDiff = 0;
+        if (m_fackEnabled)
+        {
+            uint32_t headSeq = m_txBuffer->HeadSequence().GetValue();
+            if (m_sndFack > headSeq)
+            {
+                fackDiff = m_sndFack - headSeq;
+            }
+        }
+
         // RFC 6675, Section 5, continuing:
         // ... and take the following steps:
         // (1) If DupAcks >= DupThresh, go to step (4).
@@ -1802,8 +1849,12 @@
         //     bandwidth-greedy application in high speed and reliable network
         //     (such as datacenter network) whose sending rate is constrained by
         //     TCP socket buffer size at receiver side.
-        if ((m_dupAckCount == m_retxThresh) &&
-            ((m_highRxAckMark >= m_recover) || (!m_recoverActive)))
+
+        // Check FACK recovery condition
+
+        if ((m_fackEnabled && fackDiff > m_tcb->m_segmentSize * 3) ||
+            ((m_dupAckCount == m_retxThresh) &&
+             (m_highRxAckMark >= m_recover || (!m_recoverActive))))
         {
             EnterRecovery(currentDelivered);
             NS_ASSERT(m_tcb->m_congState == TcpSocketState::CA_RECOVERY);
@@ -1996,6 +2047,19 @@
      * reaching this code if SYN or FIN is set, and e) is not supported.
      */
 
+    if (m_fackEnabled && ackNumber == m_txBuffer->HeadSequence() &&
+        m_tcb->m_congState == TcpSocketState::CA_RECOVERY)
+    {
+        if (m_outstandingRetransBytes > m_tcb->m_segmentSize)
+        {
+            m_outstandingRetransBytes -= m_tcb->m_segmentSize;
+        }
+        else
+        {
+            m_outstandingRetransBytes = 0;
+        }
+    }
+
     bool isDupack = m_sackEnabled ? scoreboardUpdated
                                   : (ackNumber == oldHeadSequence &&
                                      ackNumber < m_tcb->m_highTxMark && !receivedData);
@@ -3565,9 +3629,35 @@
 uint32_t
 TcpSocketBase::AvailableWindow() const
 {
-    uint32_t win = Window();             // Number of bytes allowed to be outstanding
-    uint32_t inflight = BytesInFlight(); // Number of outstanding bytes
-    return (inflight > win) ? 0 : win - inflight;
+    uint32_t win = Window(); // Number of bytes allowed to be outstanding
+
+    if (m_sackEnabled && m_fackEnabled && win >= m_tcb->m_ssThresh)
+    {
+        // Update awnd (Data sender's estimate of the actual quantity of data outstanding in the
+        // network)
+        NS_LOG_DEBUG("FACK is enabled and win >= ssthresh (" << m_tcb->m_ssThresh << ")");
+
+        uint32_t sndNxt = (m_tcb->m_highTxMark.Get().GetValue());
+        uint32_t retranData = m_txBuffer->GetRetransmitsCount();
+        uint32_t awnd = sndNxt - m_sndFack + retranData;
+        m_tcb->m_fackAwnd = awnd;
+
+        NS_LOG_DEBUG("SndNxt: " << sndNxt << ", SndFack: " << m_sndFack << ", AWND: " << awnd
+                                << ", RetranData :" << retranData);
+
+        uint32_t awndDiff = (win > awnd) ? (win - awnd) : 0;
+        NS_LOG_DEBUG("AWND: " << awnd << ", win: " << win << ", AWND_DIFF: " << awndDiff);
+        return awndDiff;
+    }
+
+    uint32_t inflight = BytesInFlight();
+
+    if (inflight >= win)
+    {
+        return 0;
+    }
+
+    return win - inflight;
 }
 
 uint16_t
@@ -3813,6 +3903,13 @@
     // Reset the data retransmission count. We got a new ACK!
     m_dataRetrCount = m_dataRetries;
 
+    // Update m_sndFack if possible
+    if (m_fackEnabled && ack.GetValue() > m_sndFack)
+    {
+        NS_LOG_INFO(" m_sndFack " << m_sndFack << " updated by normal ack to " << ack.GetValue());
+        m_sndFack = ack.GetValue();
+    }
+
     if (m_state != SYN_RCVD && resetRTO)
     { // Set RTO unless the ACK is received in SYN_RCVD state
         NS_LOG_LOGIC(
@@ -4160,6 +4257,18 @@
     return m_txBuffer->MaxBufferSize();
 }
 
+uint32_t
+TcpSocketBase::GetSndFack() const
+{
+    return m_sndFack;
+}
+
+bool
+TcpSocketBase::GetFackEnabled() const
+{
+    return m_fackEnabled;
+}
+
 void
 TcpSocketBase::SetRcvBufSize(uint32_t size)
 {
@@ -4397,6 +4506,21 @@
     NS_LOG_FUNCTION(this << option);
 
     Ptr<const TcpOptionSack> s = DynamicCast<const TcpOptionSack>(option);
+
+    // Update m_sndFack with the highest sequence number acknowledged from the SACK blocks
+    if (m_fackEnabled)
+    {
+        for (const auto& [leftEdge, rightEdge] : s->GetSackList())
+        {
+            if (rightEdge.GetValue() > m_sndFack)
+            {
+                NS_LOG_INFO(" m_sndFack updated from " << m_sndFack << " to "
+                                                       << rightEdge.GetValue());
+                m_sndFack = rightEdge.GetValue();
+            }
+        }
+    }
+
     return m_txBuffer->Update(s->GetSackList(), MakeCallback(&TcpRateOps::SkbDelivered, m_rateOps));
 }
 
@@ -4642,6 +4766,12 @@
 }
 
 void
+TcpSocketBase::UpdateFackAwnd(uint32_t oldValue, uint32_t newValue) const
+{
+    m_fackAwndTrace(oldValue, newValue);
+}
+
+void
 TcpSocketBase::UpdateRtt(Time oldValue, Time newValue) const
 {
     m_srttTrace(oldValue, newValue);
@@ -4806,6 +4936,24 @@
     m_tcb->m_useEcn = useEcn;
 }
 
+void
+TcpSocketBase::SetUseAbe(bool useAbe)
+{
+    NS_LOG_FUNCTION(this << useAbe);
+    if (m_tcb->m_useEcn == TcpSocketState::Off && useAbe)
+    {
+        NS_LOG_INFO("Enabling ECN along with ABE");
+        m_tcb->m_useEcn = TcpSocketState::On;
+    }
+    m_tcb->m_abeEnabled = useAbe;
+}
+
+bool
+TcpSocketBase::GetUseAbe() const
+{
+    return m_tcb->m_abeEnabled;
+}
+
 uint32_t
 TcpSocketBase::GetRWnd() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-socket-base.h ns-3.47/src/internet/model/tcp-socket-base.h
--- ns-3.46/src/internet/model/tcp-socket-base.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-socket-base.h	2026-02-16 16:08:49.621230000 -0800
@@ -370,6 +370,11 @@
     TracedCallback<uint32_t, uint32_t> m_bytesInFlightTrace;
 
     /**
+     * @brief Callback pointer for fackAwnd trace chaining
+     */
+    TracedCallback<uint32_t, uint32_t> m_fackAwndTrace;
+
+    /**
      * @brief Callback pointer for RTT trace chaining
      */
     TracedCallback<Time, Time> m_srttTrace;
@@ -445,6 +450,13 @@
     void UpdateBytesInFlight(uint32_t oldValue, uint32_t newValue) const;
 
     /**
+     * @brief Callback function to hook to TcpSocketState awnd(FACK's inflight)
+     * @param oldValue old awnd value
+     * @param newValue new awnd value
+     */
+    void UpdateFackAwnd(uint32_t oldValue, uint32_t newValue) const;
+
+    /**
      * @brief Callback function to hook to TcpSocketState rtt
      * @param oldValue old rtt value
      * @param newValue new rtt value
@@ -579,7 +591,18 @@
      * @param useEcn Mode of ECN to use.
      */
     void SetUseEcn(TcpSocketState::UseEcn_t useEcn);
-
+    /**
+     * @brief Set ABE mode of use on the socket
+     *
+     * @param useAbe Mode of ABE to use.
+     */
+    void SetUseAbe(bool useAbe);
+    /**
+     * @brief Get ABE mode of use on the socket
+     *
+     * @return true if ABE is enabled, false otherwise.
+     */
+    bool GetUseAbe() const;
     /**
      * @brief Enable or disable pacing
      * @param pacing Boolean to enable or disable pacing
@@ -661,6 +684,26 @@
                                            const Address& peerAddr,
                                            const Ptr<const TcpSocketBase> socket);
 
+    // Variables for FACK
+    uint32_t m_sndFack;                  //!< Sequence number of the forward most acknowledgement
+    uint32_t m_outstandingRetransBytes;  //!< Number of outstanding retransmitted bytes
+    TracedValue<uint32_t> m_fackAwnd{0}; //!< Tracks the inflight data calculated by FACK algorithm.
+
+    /**
+     * @brief Get the current FACK sequence number.
+     *
+     * @return The sequence number up to which data is considered
+     *         cumulatively acknowledged by FACK.
+     */
+    uint32_t GetSndFack() const;
+
+    /**
+     * @brief Check whether Forward Acknowledgment (FACK) is enabled.
+     *
+     * @return true if FACK is enabled, false otherwise.
+     */
+    bool GetFackEnabled() const;
+
   protected:
     // Implementing ns3::TcpSocket -- Attribute get/set
     // inherited, no need to doc
@@ -691,6 +734,7 @@
     Time GetPersistTimeout() const override;
     bool SetAllowBroadcast(bool allowBroadcast) override;
     bool GetAllowBroadcast() const override;
+    void NotifyConstructionCompleted() override;
 
     // Helper functions: Connection set up
 
@@ -1394,6 +1438,10 @@
     bool m_shutdownSend{false};  //!< Send no longer allowed
     bool m_shutdownRecv{false};  //!< Receive no longer allowed
     bool m_connected{false};     //!< Connection established
+    bool m_useAbe{false};        //!< ABE mode
+                                 //!< It will override the UseEcn attribute
+                                 //!< if it is 'Off' and set it to 'On', but
+                                 //!< will leave it untouched if it is 'AcceptOnly'
     double m_msl{0.0};           //!< Max segment lifetime
 
     // Window management
@@ -1413,6 +1461,8 @@
     bool m_timestampEnabled{true};  //!< Timestamp option enabled
     uint32_t m_timestampToEcho{0};  //!< Timestamp to echo
 
+    bool m_fackEnabled{false}; //!< flag for enabling FACK
+
     EventId m_sendPendingDataEvent{}; //!< micro-delay event to send pending data
 
     // Fast Retransmit and Recovery
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-socket-state.cc ns-3.47/src/internet/model/tcp-socket-state.cc
--- ns-3.46/src/internet/model/tcp-socket-state.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-socket-state.cc	2026-02-16 16:08:49.621230000 -0800
@@ -79,6 +79,11 @@
                             "The TCP connection's congestion window",
                             MakeTraceSourceAccessor(&TcpSocketState::m_bytesInFlight),
                             "ns3::TracedValueCallback::Uint32")
+            .AddTraceSource(
+                "FackAwnd",
+                "Estimate of amount of outstanding data in the network (if FACK option is enabled)",
+                MakeTraceSourceAccessor(&TcpSocketState::m_fackAwnd),
+                "ns3::TracedValueCallback::Uint32")
             .AddTraceSource("RTT",
                             "Smoothed RTT",
                             MakeTraceSourceAccessor(&TcpSocketState::m_srtt),
@@ -117,6 +122,7 @@
       m_lastRtt(other.m_lastRtt),
       m_ecnMode(other.m_ecnMode),
       m_useEcn(other.m_useEcn),
+      m_abeEnabled(other.m_abeEnabled),
       m_ectCodePoint(other.m_ectCodePoint),
       m_lastAckedSackedBytes(other.m_lastAckedSackedBytes)
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-socket-state.h ns-3.47/src/internet/model/tcp-socket-state.h
--- ns-3.46/src/internet/model/tcp-socket-state.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-socket-state.h	2026-02-16 16:08:49.622230000 -0800
@@ -197,15 +197,17 @@
     Time m_minRtt{Time::Max()}; //!< Minimum RTT observed throughout the connection
 
     TracedValue<uint32_t> m_bytesInFlight{0}; //!< Bytes in flight
-    bool m_isCwndLimited{false};              //!< Whether throughput is limited by cwnd
-    TracedValue<Time> m_srtt;                 //!< Smoothed RTT
-    TracedValue<Time> m_lastRtt;              //!< RTT of the last (S)ACKed packet
+    TracedValue<uint32_t> m_fackAwnd{0};      //!< inflight data by FACK
 
-    Ptr<TcpRxBuffer> m_rxBuffer; //!< Rx buffer (reordering buffer)
+    bool m_isCwndLimited{false}; //!< Whether throughput is limited by cwnd
+    TracedValue<Time> m_srtt;    //!< Smoothed RTT
+    TracedValue<Time> m_lastRtt; //!< RTT of the last (S)ACKed packet
 
-    EcnMode_t m_ecnMode{ClassicEcn}; //!< ECN mode
-    UseEcn_t m_useEcn{Off};          //!< Socket ECN capability
+    Ptr<TcpRxBuffer> m_rxBuffer; //!< Rx buffer (reordering buffer)
 
+    EcnMode_t m_ecnMode{ClassicEcn};     //!< ECN mode
+    UseEcn_t m_useEcn{Off};              //!< Socket ECN capability
+    bool m_abeEnabled{false};            //!< ABE mode
     EcnCodePoint_t m_ectCodePoint{Ect0}; //!< ECT code point to use
 
     uint32_t m_lastAckedSackedBytes{
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-vegas.h ns-3.47/src/internet/model/tcp-vegas.h
--- ns-3.46/src/internet/model/tcp-vegas.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-vegas.h	2026-02-16 16:08:49.622230000 -0800
@@ -122,7 +122,6 @@
 
     Ptr<TcpCongestionOps> Fork() override;
 
-  protected:
   private:
     /**
      * @brief Enable Vegas algorithm to start taking Vegas samples
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-veno.h ns-3.47/src/internet/model/tcp-veno.h
--- ns-3.46/src/internet/model/tcp-veno.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-veno.h	2026-02-16 16:08:49.622230000 -0800
@@ -128,7 +128,6 @@
 
     Ptr<TcpCongestionOps> Fork() override;
 
-  protected:
   private:
     /**
      * @brief Enable Veno algorithm to start Veno sampling
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-yeah.h ns-3.47/src/internet/model/tcp-yeah.h
--- ns-3.46/src/internet/model/tcp-yeah.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-yeah.h	2026-02-16 16:08:49.622230000 -0800
@@ -129,7 +129,6 @@
 
     Ptr<TcpCongestionOps> Fork() override;
 
-  protected:
   private:
     /**
      * @brief Enable YeAH algorithm to start taking YeAH samples
